Index: .gitignore
===================================================================
--- .gitignore	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ .gitignore	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -22,4 +22,8 @@
 /config.h
 /cscope.out
+doxygen/doxygen.cfg
+doxygen/doxygen.cfg.gen
+doxygen/html/
+doxygen/latex/
 /hdisk.img
 /image.iso
@@ -248,4 +252,5 @@
 uspace/dist/logo.tga
 uspace/dist/srv/cdfs
+uspace/dist/srv/chardev-test
 uspace/dist/srv/clipboard
 uspace/dist/srv/compositor
@@ -420,4 +425,19 @@
 uspace/srv/ns/ns
 uspace/srv/taskmon/taskmon
+uspace/srv/test/chardev-test/chardev-test
 uspace/srv/vfs/vfs
 uspace/srv/volsrv/volsrv
+tools/amd64-unknown-elf
+tools/arm-linux-gnueabi
+tools/i686-pc-linux-gnu
+tools/ia64-pc-linux-gnu
+tools/mips-linux-gnu
+tools/mips64el-linux-gnu
+tools/mipsel-linux-gnu
+tools/ppc-linux-gnu
+tools/ppc64-linux-gnu
+tools/riscv64-unknown-linux-gnu
+tools/sparc64-linux-gnu
+tools/binutils-*.tar.bz2
+tools/gcc-*.tar.bz2
+tools/gdb-*.tar.gz
Index: Makefile
===================================================================
--- Makefile	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ Makefile	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -73,4 +73,7 @@
 	find abi kernel boot uspace -type f -regex '^.*\.[ch]$$' | xargs $(FORMAT) -i -sort-includes -style=file
 
+doxy:
+	$(MAKE) -r -C doxygen
+
 # Pre-integration build check
 check: $(CHECK)
@@ -120,4 +123,5 @@
 	$(MAKE) -r -C uspace clean
 	$(MAKE) -r -C boot clean
+	$(MAKE) -r -C doxygen clean
 
 -include Makefile.local
Index: abi/include/abi/cap.h
===================================================================
--- abi/include/abi/cap.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ abi/include/abi/cap.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2017 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef ABI_CAP_H_
+#define ABI_CAP_H_
+
+#define CAP_NIL		0
+
+typedef int cap_handle_t;
+
+#endif
+
+/** @}
+ */
Index: abi/include/abi/errno.h
===================================================================
--- abi/include/abi/errno.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ abi/include/abi/errno.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -41,11 +41,12 @@
  */
 
-#define EOK             0   /* No error */
-#define ENOENT         -1   /* No such entry */
-#define ENOMEM         -2   /* Not enough memory */
-#define ELIMIT         -3   /* Limit exceeded */
-#define EREFUSED       -4   /* Connection refused */
-#define EFORWARD       -5   /* Forward error */
-#define EPERM          -6   /* Permission denied */
+typedef enum {
+	EOK           =  0,   /* No error */
+	ENOENT        = -1,   /* No such entry */
+	ENOMEM        = -2,   /* Not enough memory */
+	ELIMIT        = -3,   /* Limit exceeded */
+	EREFUSED      = -4,   /* Connection refused */
+	EFORWARD      = -5,   /* Forward error */
+	EPERM         = -6,   /* Permission denied */
 
 /*
@@ -54,5 +55,5 @@
  * Used by answerbox to close the connection.
  */
-#define EHANGUP        -7
+	EHANGUP       = -7,
 
 /*
@@ -60,15 +61,47 @@
  * receiving the call.
  */
-#define EPARTY         -8
+	EPARTY        = -8,
 
-#define EEXIST         -9   /* Entry already exists */
-#define EBADMEM        -10  /* Bad memory pointer */
-#define ENOTSUP        -11  /* Not supported */
-#define EADDRNOTAVAIL  -12  /* Address not available. */
-#define ETIMEOUT       -13  /* Timeout expired */
-#define EINVAL         -14  /* Invalid value */
-#define EBUSY          -15  /* Resource is busy */
-#define EOVERFLOW      -16  /* The result does not fit its size. */
-#define EINTR          -17  /* Operation was interrupted. */
+	EEXIST        = -9,   /* Entry already exists */
+	EBADMEM       = -10,  /* Bad memory pointer */
+	ENOTSUP       = -11,  /* Not supported */
+	EADDRNOTAVAIL = -12,  /* Address not available. */
+	ETIMEOUT      = -13,  /* Timeout expired */
+	EINVAL        = -14,  /* Invalid value */
+	EBUSY         = -15,  /* Resource is busy */
+	EOVERFLOW     = -16,  /* The result does not fit its size. */
+	EINTR         = -17,  /* Operation was interrupted. */
+
+	EMFILE        = -18,
+	ENAMETOOLONG  = -256,
+	EISDIR        = -257,
+	ENOTDIR       = -258,
+	ENOSPC        = -259,
+	ENOTEMPTY     = -261,
+	EBADF         = -262,
+	EDOM          = -263,
+	ERANGE        = -264,
+	EXDEV         = -265,
+	EIO           = -266,
+	EMLINK        = -267,
+	ENXIO         = -268,
+	ENOFS         = -269,
+
+/** Bad checksum. */
+	EBADCHECKSUM  = -300,
+
+/** USB: stalled operation. */
+	ESTALL        = -301,
+
+/** Empty resource (no data). */
+	EEMPTY        = -302,
+
+/** Negative acknowledgment. */
+	ENAK          = -303,
+
+/** The requested operation was not performed. Try again later. */
+	EAGAIN        = -11002,
+} errno_t;
+
 
 #endif
Index: abi/include/abi/ipc/ipc.h
===================================================================
--- abi/include/abi/ipc/ipc.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ abi/include/abi/ipc/ipc.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,5 +38,5 @@
 /** Length of data being transfered with IPC call
  *
- * The uspace may not be able to utilize full length
+ * The uspace may not be able to utilize the full length
  *
  */
@@ -49,5 +49,5 @@
 
 /** This is answer to a call */
-#define IPC_CALL_ANSWERED  (1 << 0)
+#define IPC_CALL_ANSWERED        (1 << 0)
 
 /** Answer will not be passed to userspace, will be discarded */
@@ -55,8 +55,8 @@
 
 /** Call was forwarded */
-#define IPC_CALL_FORWARDED  (1 << 2)
+#define IPC_CALL_FORWARDED       (1 << 2)
 
 /** Interrupt notification */
-#define IPC_CALL_NOTIF  (1 << 3)
+#define IPC_CALL_NOTIF           (1 << 3)
 
 /**
@@ -65,21 +65,4 @@
  */
 #define DATA_XFER_LIMIT  (64 * 1024)
-
-
-/** Bits used in call hashes.
- *
- * The addresses are aligned at least to 4 that is why we can use the 2 least
- * significant bits of the call address.
- *
- */
-
-/** Type of this call is 'answer' */
-#define IPC_CALLID_ANSWERED  1
-
-/** Type of this call is 'notification' */
-#define IPC_CALLID_NOTIFICATION  2
-
-/* Return values from sys_ipc_call_async(). */
-#define IPC_CALLRET_FATAL      -1
 
 /* Macros for manipulating calling data */
Index: abi/include/abi/ipc/methods.h
===================================================================
--- abi/include/abi/ipc/methods.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ abi/include/abi/ipc/methods.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,6 +36,8 @@
 #define ABI_IPC_METHODS_H_
 
+#include <abi/cap.h>
+
 /* Well known phone descriptors */
-#define PHONE_NS  0
+#define PHONE_NS  (CAP_NIL + 1)
 
 /** Kernel IPC interfaces
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ boot/Makefile.common	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -123,4 +123,5 @@
 	$(USPACE_PATH)/srv/net/udp/udp \
 	$(USPACE_PATH)/srv/taskmon/taskmon \
+	$(USPACE_PATH)/srv/test/chardev-test/chardev-test \
 	$(USPACE_PATH)/srv/volsrv/volsrv
 
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ boot/arch/amd64/Makefile.inc	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,4 +35,5 @@
 	intctl/i8259 \
 	platform/pc \
+	block/ata_bd \
 	bus/pci/pciintel \
 	bus/isa \
Index: contrib/qemu/build-from-scratch.sh
===================================================================
--- contrib/qemu/build-from-scratch.sh	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ contrib/qemu/build-from-scratch.sh	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -29,5 +29,5 @@
 #
 
-VERSION=2.10.0
+VERSION=2.11.0
 BASENAME=qemu-${VERSION}
 BASENAME_MASTER=qemu-master
@@ -36,5 +36,5 @@
 URL=http://wiki.qemu-project.org/download/${TARBALL}
 REPO=git://git.qemu.org/qemu.git
-MD5="ca73441de73a9b52c6c49c97190d2185"
+MD5="335994a755bc655e88a87aeb36bfc0b9"
 
 OPENSPARC_TARBALL="OpenSPARCT1_Arch.1.5.tar.bz2"
Index: doxygen/Makefile
===================================================================
--- doxygen/Makefile	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ doxygen/Makefile	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,46 @@
+#
+# Copyright (c) 2017 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+cfg_file = doxygen.cfg
+gen_cfg = doxygen.cfg.gen
+patch_file = doxygen.cfg.diff
+output_dirs = latex html
+
+all: doxygen.cfg
+	doxygen $^
+
+clean:
+	rm -f $(gen_cfg) $(cfg_file)
+	rm -rf $(output_dirs)
+
+$(cfg_file): $(gen_cfg)
+	cp $^ $@
+	patch $@ $(patch_file)
+
+$(gen_cfg):
+	doxygen -g $@
Index: kernel/arch/ia32/src/smp/mps.c
===================================================================
--- kernel/arch/ia32/src/smp/mps.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/arch/ia32/src/smp/mps.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -91,5 +91,5 @@
 		return false;
 	
-	return (bool) ((processor_entries[i].cpu_flags & 0x01) == 0x01);
+	return ((processor_entries[i].cpu_flags & 0x01) == 0x01);
 }
 
@@ -98,5 +98,5 @@
 	assert(i < processor_entry_cnt);
 	
-	return (bool) ((processor_entries[i].cpu_flags & 0x02) == 0x02);
+	return ((processor_entries[i].cpu_flags & 0x02) == 0x02);
 }
 
Index: kernel/arch/sparc64/include/arch/drivers/niagara_buf.h
===================================================================
--- kernel/arch/sparc64/include/arch/drivers/niagara_buf.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
+++ kernel/arch/sparc64/include/arch/drivers/niagara_buf.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2008 Pavel Rimsky
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup sparc64
+ * @{
+ */
+/**
+ * @file
+ * @brief Niagara input/output buffer shared between kernel and user space
+ */
+
+#ifdef KERNEL
+#include <mm/as.h>
+#else
+#include <as.h>
+#endif
+
+#include <stdint.h>
+
+#define OUTPUT_BUFFER_SIZE  ((PAGE_SIZE) - 2 * 8)
+
+typedef struct {
+	uint64_t read_ptr;
+	uint64_t write_ptr;
+	char data[OUTPUT_BUFFER_SIZE];
+} __attribute__ ((packed)) niagara_output_buffer_t;
+
+#define INPUT_BUFFER_SIZE  ((PAGE_SIZE) - 2 * 8)
+
+typedef struct {
+	uint64_t write_ptr;
+	uint64_t read_ptr;
+	char data[INPUT_BUFFER_SIZE];
+} __attribute__ ((packed)) niagara_input_buffer_t;
+
+/** @}
+ */
Index: kernel/arch/sparc64/src/drivers/niagara.c
===================================================================
--- kernel/arch/sparc64/src/drivers/niagara.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/arch/sparc64/src/drivers/niagara.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -42,4 +42,5 @@
 #include <arch.h>
 #include <mm/slab.h>
+#include <arch/drivers/niagara_buf.h>
 #include <arch/drivers/kbd.h>
 #include <arch/sun4v/hypercall.h>
@@ -81,11 +82,6 @@
  * buffer definition follows.
  */
-#define OUTPUT_BUFFER_SIZE  ((PAGE_SIZE) - 2 * 8)
-
-static volatile struct {
-	uint64_t read_ptr;
-	uint64_t write_ptr;
-	char data[OUTPUT_BUFFER_SIZE];
-} __attribute__ ((packed)) __attribute__ ((aligned(PAGE_SIZE))) output_buffer;
+static volatile niagara_output_buffer_t __attribute__ ((aligned(PAGE_SIZE)))
+    output_buffer;
 
 static parea_t outbuf_parea;
@@ -94,11 +90,6 @@
  * Analogous to the output_buffer, see the previous definition.
  */
-#define INPUT_BUFFER_SIZE  ((PAGE_SIZE) - 2 * 8)
-
-static volatile struct {
-	uint64_t write_ptr;
-	uint64_t read_ptr;
-	char data[INPUT_BUFFER_SIZE];
-} __attribute__ ((packed)) __attribute__ ((aligned(PAGE_SIZE))) input_buffer;
+static volatile niagara_input_buffer_t __attribute__ ((aligned(PAGE_SIZE)))
+    input_buffer;
 
 static parea_t inbuf_parea;
Index: kernel/arch/sparc64/src/smp/sun4v/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -81,66 +81,4 @@
 unsigned int max_core_strands = 0;
 
-#ifdef CONFIG_SIMICS_SMP_HACK
-/**
- * Copies a piece of HelenOS code to the place where OBP had its IPI handler.
- * By sending an IPI by the BSP to the AP the code will be executed.
- * The code will jump to the first instruction of the kernel. This is
- * a workaround how to make APs execute HelenOS code on Simics.
- */
-static void simics_smp_hack_init(void) {
-	asm volatile (
-		"setx temp_cpu_mondo_handler, %g4, %g6 \n"
-		"setx 0x80200f80, %g4, %g7 \n"
-
-		"ldx [%g6], %g4 \n"
-		"stxa %g4, [%g7] 0x14 \n"
-		"membar #Sync \n"
-
-		"add %g7, 0x8, %g7 \n"
-		"ldx [%g6 + 0x8], %g4 \n"
-		"stxa %g4, [%g7] 0x14 \n"
-		"membar #Sync \n"
-
-		"add %g7, 0x8, %g7 \n"
-		"ldx [%g6 + 0x10], %g4 \n"
-		"stxa %g4, [%g7] 0x14 \n"
-		"membar #Sync \n"
-
-		"add %g7, 0x8, %g7 \n"
-		"ldx [%g6 + 0x18], %g4 \n"
-		"stxa %g4, [%g7] 0x14 \n"
-		"membar #Sync \n"
-
-		"add %g7, 0x8, %g7 \n"
-		"ldx [%g6 + 0x20], %g4 \n"
-		"stxa %g4, [%g7] 0x14 \n"
-		"membar #Sync \n"
-
-		"add %g7, 0x8, %g7 \n"
-		"ldx [%g6 + 0x28], %g4 \n"
-		"stxa %g4, [%g7] 0x14 \n"
-		"membar #Sync \n"
-
-		"add %g7, 0x8, %g7 \n"
-		"ldx [%g6 + 0x30], %g4 \n"
-		"stxa %g4, [%g7] 0x14 \n"
-		"membar #Sync \n"
-
-		"add %g7, 0x8, %g7 \n"
-		"ldx [%g6 + 0x38], %g4 \n"
-		"stxa %g4, [%g7] 0x14 \n"
-		"membar #Sync \n"
-
-		"add %g7, 0x8, %g7 \n"
-		"ldx [%g6 + 0x40], %g4 \n"
-		"stxa %g4, [%g7] 0x14 \n"
-		"membar #Sync \n"
-
-		"flush %i7"
-
-		);
-}
-#endif
-
 #if 0
 /**
@@ -372,7 +310,4 @@
 {
 	detect_execution_units();
-#ifdef CONFIG_SIMICS_SMP_HACK
-	simics_smp_hack_init();
-#endif
 }
 
Index: kernel/arch/sparc64/src/sun4v/start.S
===================================================================
--- kernel/arch/sparc64/src/sun4v/start.S	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/arch/sparc64/src/sun4v/start.S	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -309,21 +309,4 @@
 	ba,a %xcc, 0b
 
-.align 8
-SYMBOL(temp_cpu_mondo_handler)
-
-	set 0x3c, %o0
-	set 0x15, %o5
-	ta 0x80
-
-	mov 0, %o0
-	setx before_ap_boots, %g1, %o1
-	setx 0x80400000, %g1, %o2
-	add %o1, %o2, %o1
-	__HYPERCALL_FAST(MMU_ENABLE)
-
-before_ap_boots:
-	setx 0x80400000, %g1, %o0
-	ba,a %xcc, kernel_image_start
-
 .section K_DATA_START, "aw", @progbits
 
Index: kernel/generic/include/cap/cap.h
===================================================================
--- kernel/generic/include/cap/cap.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/include/cap/cap.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,4 +36,5 @@
 #define KERN_CAP_H_
 
+#include <abi/cap.h>
 #include <typedefs.h>
 #include <adt/list.h>
@@ -44,6 +45,4 @@
 #include <atomic.h>
 
-typedef int cap_handle_t;
-
 typedef enum {
 	CAP_STATE_FREE,
@@ -53,12 +52,15 @@
 
 typedef enum {
+	KOBJECT_TYPE_CALL,
+	KOBJECT_TYPE_IRQ,
 	KOBJECT_TYPE_PHONE,
-	KOBJECT_TYPE_IRQ,
 	KOBJECT_TYPE_MAX
 } kobject_type_t;
 
 struct task;
+
+struct call;
+struct irq;
 struct phone;
-struct irq;
 
 struct kobject;
@@ -79,6 +81,7 @@
 	union {
 		void *raw;
+		struct call *call;
+		struct irq *irq;
 		struct phone *phone;
-		struct irq *irq;
 	};
 } kobject_t;
Index: kernel/generic/include/ddi/irq.h
===================================================================
--- kernel/generic/include/ddi/irq.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/include/ddi/irq.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -132,5 +132,5 @@
 extern hash_table_t irq_uspace_hash_table;
 
-extern slab_cache_t *irq_slab;
+extern slab_cache_t *irq_cache;
 
 extern inr_t last_inr;
Index: kernel/generic/include/ipc/ipc.h
===================================================================
--- kernel/generic/include/ipc/ipc.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/include/ipc/ipc.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -106,7 +106,15 @@
 	/** Phone which made or last masqueraded this call. */
 	phone_t *phone;
+	/** Flags */
+	unsigned flags;
+	/** User-defined label */
+	sysarg_t label;
+	/** Capability handle */
+	cap_handle_t cap_handle;
 } ipc_data_t;
 
-typedef struct {
+typedef struct call {
+	kobject_t *kobject;
+
 	/**
 	 * Task link.
@@ -115,6 +123,4 @@
 	 */
 	link_t ta_link;
-
-	atomic_t refcnt;
 
 	/** Answerbox link. */
@@ -169,5 +175,5 @@
 } call_t;
 
-extern slab_cache_t *phone_slab;
+extern slab_cache_t *phone_cache;
 
 extern answerbox_t *ipc_phone_0;
Index: kernel/generic/include/ipc/ipcrsc.h
===================================================================
--- kernel/generic/include/ipc/ipcrsc.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/include/ipc/ipcrsc.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -40,5 +40,4 @@
 #include <cap/cap.h>
 
-extern call_t *get_call(sysarg_t);
 extern cap_handle_t phone_alloc(task_t *);
 extern bool phone_connect(cap_handle_t, answerbox_t *);
Index: kernel/generic/include/ipc/irq.h
===================================================================
--- kernel/generic/include/ipc/irq.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/include/ipc/irq.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -51,5 +51,6 @@
 extern void ipc_irq_top_half_handler(irq_t *);
 
-extern int ipc_irq_subscribe(answerbox_t *, inr_t, sysarg_t, irq_code_t *);
+extern int ipc_irq_subscribe(answerbox_t *, inr_t, sysarg_t, irq_code_t *,
+    cap_handle_t *);
 extern int ipc_irq_unsubscribe(answerbox_t *, int);
 
Index: kernel/generic/include/ipc/kbox.h
===================================================================
--- kernel/generic/include/ipc/kbox.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/include/ipc/kbox.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -50,5 +50,5 @@
 } kbox_t;
 
-extern int ipc_connect_kbox(task_id_t);
+extern int ipc_connect_kbox(task_id_t, cap_handle_t *);
 extern void ipc_kbox_cleanup(void);
 
Index: kernel/generic/include/ipc/sysipc.h
===================================================================
--- kernel/generic/include/ipc/sysipc.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/include/ipc/sysipc.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -44,5 +44,5 @@
 extern sysarg_t sys_ipc_call_async_fast(sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t);
-extern sysarg_t sys_ipc_call_async_slow(sysarg_t, ipc_data_t *);
+extern sysarg_t sys_ipc_call_async_slow(sysarg_t, ipc_data_t *, sysarg_t);
 extern sysarg_t sys_ipc_answer_fast(sysarg_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t);
@@ -56,18 +56,8 @@
 extern sysarg_t sys_ipc_hangup(sysarg_t);
 
-extern sysarg_t sys_ipc_irq_subscribe(inr_t, sysarg_t, irq_code_t *);
+extern sysarg_t sys_ipc_irq_subscribe(inr_t, sysarg_t, irq_code_t *, cap_handle_t *);
 extern sysarg_t sys_ipc_irq_unsubscribe(sysarg_t);
 
-#ifdef __32_BITS__
-
-extern sysarg_t sys_ipc_connect_kbox(sysarg64_t *);
-
-#endif  /* __32_BITS__ */
-
-#ifdef __64_BITS__
-
-extern sysarg_t sys_ipc_connect_kbox(sysarg_t);
-
-#endif  /* __64_BITS__ */
+extern sysarg_t sys_ipc_connect_kbox(task_id_t *, cap_handle_t *);
 
 #endif
Index: kernel/generic/include/log.h
===================================================================
--- kernel/generic/include/log.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/include/log.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -52,5 +52,5 @@
 
 extern sysarg_t sys_klog(sysarg_t, void *buf, size_t size,
-    sysarg_t level);
+    sysarg_t level, size_t *uspace_nread);
 
 #endif /* KERN_LOG_H_ */
Index: kernel/generic/include/proc/thread.h
===================================================================
--- kernel/generic/include/proc/thread.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/include/proc/thread.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -272,5 +272,5 @@
 
 /** Fpu context slab cache. */
-extern slab_cache_t *fpu_context_slab;
+extern slab_cache_t *fpu_context_cache;
 
 /* Thread syscall prototypes. */
Index: kernel/generic/include/udebug/udebug_ops.h
===================================================================
--- kernel/generic/include/udebug/udebug_ops.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/include/udebug/udebug_ops.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,6 +37,9 @@
 
 #include <ipc/ipc.h>
+#include <proc/thread.h>
+#include <stdbool.h>
+#include <stddef.h>
 
-int udebug_begin(call_t *call);
+int udebug_begin(call_t *call, bool *active);
 int udebug_end(void);
 int udebug_set_evmask(udebug_evmask_t mask);
Index: kernel/generic/src/adt/btree.c
===================================================================
--- kernel/generic/src/adt/btree.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/adt/btree.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -55,5 +55,5 @@
 #include <trace.h>
 
-static slab_cache_t *btree_node_slab;
+static slab_cache_t *btree_node_cache;
 
 #define ROOT_NODE(n)   (!(n)->parent)
@@ -71,5 +71,5 @@
 void btree_init(void)
 {
-	btree_node_slab = slab_cache_create("btree_node_t",
+	btree_node_cache = slab_cache_create("btree_node_t",
 	    sizeof(btree_node_t), 0, NULL, NULL, SLAB_CACHE_MAGDEFERRED);
 }
@@ -109,5 +109,5 @@
 {
 	list_initialize(&t->leaf_list);
-	t->root = (btree_node_t *) slab_alloc(btree_node_slab, 0);
+	t->root = (btree_node_t *) slab_alloc(btree_node_cache, 0);
 	node_initialize(t->root);
 	list_append(&t->root->leaf_link, &t->leaf_list);
@@ -130,5 +130,5 @@
 	}
 	
-	slab_free(btree_node_slab, root);
+	slab_free(btree_node_cache, root);
 }
 
@@ -516,5 +516,5 @@
 	 * Allocate and initialize new right sibling.
 	 */
-	rnode = (btree_node_t *) slab_alloc(btree_node_slab, 0);
+	rnode = (btree_node_t *) slab_alloc(btree_node_cache, 0);
 	node_initialize(rnode);
 	rnode->parent = node->parent;
@@ -595,5 +595,5 @@
 			 * We split the root node. Create new root.
 			 */
-			t->root = (btree_node_t *) slab_alloc(btree_node_slab, 0);
+			t->root = (btree_node_t *) slab_alloc(btree_node_cache, 0);
 			node->parent = t->root;
 			rnode->parent = t->root;
@@ -779,5 +779,5 @@
 			t->root = node->subtree[0];
 			t->root->parent = NULL;
-			slab_free(btree_node_slab, node);
+			slab_free(btree_node_cache, node);
 		} else {
 			/*
@@ -838,5 +838,5 @@
 		idx = find_key_by_subtree(parent, rnode, true);
 		assert((int) idx != -1);
-		slab_free(btree_node_slab, rnode);
+		slab_free(btree_node_cache, rnode);
 		_btree_remove(t, parent->key[idx], parent);
 	}
Index: kernel/generic/src/cap/cap.c
===================================================================
--- kernel/generic/src/cap/cap.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/cap/cap.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -41,4 +41,5 @@
  * A kernel object (kobject_t) encapsulates one of the following raw objects:
  *
+ * - IPC call
  * - IPC phone
  * - IRQ object
@@ -73,4 +74,5 @@
 
 #include <cap/cap.h>
+#include <abi/cap.h>
 #include <proc/task.h>
 #include <synch/mutex.h>
@@ -81,7 +83,9 @@
 #include <stdint.h>
 
-#define MAX_CAPS	INT_MAX
-
-static slab_cache_t *cap_slab;
+#define CAPS_START	(CAP_NIL + 1)
+#define CAPS_SIZE	(INT_MAX - CAPS_START)
+#define CAPS_LAST	(CAPS_SIZE - 1)
+
+static slab_cache_t *cap_cache;
 
 static size_t caps_hash(const ht_link_t *item)
@@ -112,5 +116,5 @@
 void caps_init(void)
 {
-	cap_slab = slab_cache_create("cap_t", sizeof(cap_t), 0, NULL,
+	cap_cache = slab_cache_create("cap_t", sizeof(cap_t), 0, NULL,
 	    NULL, 0);
 }
@@ -129,5 +133,5 @@
 	if (!task->cap_info->handles)
 		goto error_handles;
-	if (!ra_span_add(task->cap_info->handles, 0, MAX_CAPS))
+	if (!ra_span_add(task->cap_info->handles, CAPS_START, CAPS_SIZE))
 		goto error_span;
 	if (!hash_table_create(&task->cap_info->caps, 0, 0, &caps_ops))
@@ -220,5 +224,5 @@
 	assert(mutex_locked(&task->cap_info->lock));
 
-	if ((handle < 0) || (handle >= MAX_CAPS))
+	if ((handle < CAPS_START) || (handle > CAPS_LAST))
 		return NULL;
 	ht_link_t *link = hash_table_find(&task->cap_info->caps, &handle);
@@ -273,5 +277,5 @@
 	 */
 	if (!cap) {
-		cap = slab_alloc(cap_slab, FRAME_ATOMIC);
+		cap = slab_alloc(cap_cache, FRAME_ATOMIC);
 		if (!cap) {
 			mutex_unlock(&task->cap_info->lock);
@@ -280,5 +284,5 @@
 		uintptr_t hbase;
 		if (!ra_alloc(task->cap_info->handles, 1, 1, &hbase)) {
-			slab_free(cap_slab, cap);
+			slab_free(cap_cache, cap);
 			mutex_unlock(&task->cap_info->lock);
 			return ENOMEM;
@@ -357,6 +361,6 @@
 void cap_free(task_t *task, cap_handle_t handle)
 {
-	assert(handle >= 0);
-	assert(handle < MAX_CAPS);
+	assert(handle >= CAPS_START);
+	assert(handle <= CAPS_LAST);
 
 	mutex_lock(&task->cap_info->lock);
@@ -367,5 +371,5 @@
 	hash_table_remove_item(&task->cap_info->caps, &cap->caps_link);
 	ra_free(task->cap_info->handles, handle, 1);
-	slab_free(cap_slab, cap);
+	slab_free(cap_cache, cap);
 	mutex_unlock(&task->cap_info->lock);
 }
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/console/cmd.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -497,9 +497,9 @@
 };
 
-static int cmd_slabs(cmd_arg_t *argv);
-static cmd_info_t slabs_info = {
-	.name = "slabs",
+static int cmd_caches(cmd_arg_t *argv);
+static cmd_info_t caches_info = {
+	.name = "caches",
 	.description = "List slab caches.",
-	.func = cmd_slabs,
+	.func = cmd_caches,
 	.argc = 0
 };
@@ -605,4 +605,5 @@
 	&call0_info,
 	&mcall0_info,
+	&caches_info,
 	&call1_info,
 	&call2_info,
@@ -620,5 +621,4 @@
 	&sched_info,
 	&set4_info,
-	&slabs_info,
 	&symaddr_info,
 	&sysinfo_info,
@@ -1214,11 +1214,11 @@
 }
 
-/** Command for listings SLAB caches
- *
- * @param argv Ignores
+/** Command for listing slab allocator caches
+ *
+ * @param argv Ignored
  *
  * @return Always 1
  */
-int cmd_slabs(cmd_arg_t *argv)
+int cmd_caches(cmd_arg_t *argv)
 {
 	slab_print_list();
Index: kernel/generic/src/ddi/irq.c
===================================================================
--- kernel/generic/src/ddi/irq.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ kernel/generic/src/ddi/irq.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -50,5 +50,5 @@
 #include <arch.h>
 
-slab_cache_t *irq_slab = NULL;
+slab_cache_t *irq_cache = NULL;
 
 /** Spinlock protecting the kernel IRQ hash table
@@ -97,7 +97,7 @@
 	last_inr = inrs - 1;
 
-	irq_slab = slab_cache_create("irq_t", sizeof(irq_t), 0, NULL, NULL,
+	irq_cache = slab_cache_create("irq_t", sizeof(irq_t), 0, NULL, NULL,
 	    FRAME_ATOMIC);
-	assert(irq_slab);
+	assert(irq_cache);
 
 	hash_table_create(&irq_uspace_hash_table, chains, 0, &irq_ht_ops);
